<?php
class GDP_AdminPage extends GDP_WP_Admin_page_
{
	const per_page = false;

	const screen		= GDPress_page_dashboard;
	const capability	= 'GDPress_manage_dashboard';
	const help_url		= false;
	const file		= __FILE__;

////  Title  ////

	public static function title() 
	{ 
		new GDP_Dashboard();

		global $title; 
		$title = __( 'GDPress | Dashboard', 'GDPress' ); 
	}

//// Help ////

	public static function add_help_tab() 
	{
		global $current_screen;

		$content = '';
		$content .= '<p><strong>' . __( 'Dashboard :', 'GDPress' ) . '</strong></p>';

		$content .= '<p>' . __( 'Here are listed several ressources that can be usefull to help you apply GDPR on your site and reach the best possible compliance.', 'GDPress' ) . '</p>';

		$current_screen->add_help_tab( array( 	'id'		=> 'overview',
							'title'		=> __( 'Overview' ),
							'content'	=> $content )
		);
	}

////  Styles  ////

	public static function print_styles( $s ) 
	{
		$styles = ( is_array( $s ) ) ? $s : array();

		$styles[] = 'dashboard';

		wp_register_style( self::screen, 	'/' . GDP_PATH . 'gp-admin/css/dashboard.css' );
		wp_register_style( '_flags', 		'/' . GDP_PATH . 'gp-admin/css/_flags.css', array( self::screen ) );
		$styles[] = '_flags';

		parent::print_styles( $styles );
	}

////  Scripts  ////

	public static function print_scripts( $scripts = array() )
	{
		wp_register_script( self::screen, 		'/' . GDP_PATH . 'gp-admin/js/dashboard.js', array( 'postbox' ), false, 1 );
		wp_localize_script( self::screen, 		'GDP_AdminPageL10n',  array( 'screen' => self::screen ) );

		$scripts[] = self::screen;
		parent::print_scripts( $scripts );
	}

////  Metaboxes  ////

	public static function admin_head() 
	{
		do_action( 'GDPress_dashboard_add_meta_box', self::screen );
		parent::admin_head();
	}
}