<?php

if ( !( function_exists( 'current_user_can' ) && current_user_can( GDP_AdminPage::capability ) ) ) die( 'Access denied' );

$url_parms = GDP_AdminPage::get_url_parms();

global $title;

$searchtitle = '';
$subtitle = '';

if ( !isset( $url_parms['message'] ) )
{
	if ( isset( $url_parms['s'] ) ) $searchtitle = sprintf( __( 'Search results for &#8220;%s&#8221;', 'GDPress' ), esc_attr( $url_parms['s'] ) );
	if ( isset( $url_parms['author'] ) ) 
	{
		if ( ( isset( $url_parms['s'] ) ) && ( $url_parms['s'] == $url_parms['author'] ) ) $searchtitle = '';
		$author_user = get_userdata( $url_parms['author'] );
		$subtitle .= ' ' . sprintf( __( 'by %s' ), esc_html( $author_user->display_name ?? __( 'unknown wp user id', 'GDPress' ) ) );
		if ( empty( $url_parms['s'] ) ) $url_parms['s'] = $url_parms['author'];
	}
	if ( isset( $url_parms['ip'] ) ) 
	{
		if ( ( isset( $url_parms['s'] ) ) && ( $url_parms['s'] == $url_parms['ip'] ) ) $searchtitle = '';
		$subtitle .= ' ' . sprintf( __( 'by %s' ), esc_html( $url_parms['ip'] ) );
		if ( empty( $url_parms['s'] ) ) $url_parms['s'] = $url_parms['ip'];
	}
	if ( isset( $url_parms['data_subject'] ) ) 
	{
		$subtitle .= ' ' . esc_html( ( $url_parms['data_subject'] ) ? __( '(personal events)', 'GDPress' ) : __( '(internal events)', 'GDPress' ) );
	}
}

//
// MANAGING MESSAGE
//

$messages[1] = __( 'Enter a valid search argument (email, ip, wp user id).', 'GDPress' );

$wrong = null;
if ( isset( GDP_AdminPage::$get_['message'] ) )
{
	$wrong      = GDP_AdminPage::$get_['message'];
	$message = __( 'Enter a valid search argument (email, ip, wp user id).', 'GDPress' );
	$_SERVER['REQUEST_URI'] = remove_query_arg( array( 'message' ), $_SERVER['REQUEST_URI'] );
}

//
// MANAGING LIST
//

$url_parms['paged'] = $url_parms['paged'] ?? 1;
$_per_page = GDP_AdminPage::get_per_page();

do
{
	$start = ( $url_parms['paged'] - 1 ) * $_per_page;
	list( $items, $total, $subsubsub_urls ) = GDP_AdminPage::get_list( array( 'start' => $start, '_per_page' => $_per_page, 'url_parms' => $url_parms ) );
	$url_parms['paged']--;		
} while ( $total <= $start );
$url_parms['paged']++;

?>
<div class="wrap">
	<h1>
		<?php echo esc_html( $title ); ?>
<?php if ( !empty( $searchtitle ) ) echo '<span class="subtitle">' . $searchtitle . '</span>'; ?>
<?php if ( !empty( $subtitle ) )    echo '<span class="subtitle">' . $subtitle    . '</span>'; ?>
	</h1>
<?php if ( isset( $message ) ) GDP_AdminPage::message( $message ); ?>



	<form id="posts-filter" method="get">

		<input type="hidden" name="page" value="<?php echo GDP_AdminPage::screen; ?>" />

		<p class="search-box<?php if ( isset( $wrong ) ) echo ' form-invalid'; ?>">
			<input type="text" name="s" class="search-input" placeholder="<?php echo esc_attr( __( 'email, ip, wp user id', 'GDPress' ) ); ?>" value="<?php echo esc_attr( $url_parms['s'] ?? $wrong ?? ''); ?>" />
			<input type="submit" class="button" value="<?php _e( 'Search', 'GDPress' ); ?>" />
		</p>
<?php
if ( $items )
{
?>
		<div class="tablenav top">
<?php GDP_AdminPage::pagination( $total ); ?>
			<ul class="subsubsub"><?php if ( $total ) echo $subsubsub_urls; ?></ul>
			<br class="clear" />
		</div>
		<div class="clear"></div>

		<table class="wp-list-table widefat fixed striped posts event">
			<thead>
				<tr>
<?php GDP_AdminPage::columns_list(); ?>
				</tr>
			</thead>
			<tbody id="the-event-list" class="list:event">
<?php foreach ( $items as $item ) { echo GDP_AdminPage::get_row( $item->id, $url_parms ); } ?>
			</tbody>
			<tfoot>
				<tr>
<?php GDP_AdminPage::columns_list( false ); ?>
				</tr>
			</tfoot>
		</table>
		<div class="tablenav bottom">
<?php GDP_AdminPage::pagination( $total, 'bottom' ); ?>
			<br class="clear" />
		</div>
	</form>

	<form id="get-extra-events" method="post" class="hidden add:the-extra-event-list:">

<?php GDP_AdminPage::post_url_parms( ( array ) $url_parms ); ?>
<?php wp_nonce_field( 'add-event', '_ajax_nonce', false ); ?>

	</form>

	<div id="ajax-response"></div>

<?php
}
else
{
?>
	</form>
	<div class="clear"></div>
	<p>
		<?php _e( 'No results found matching your criteria.', 'GDPress' ) ?>
	</p>
<?php
}
?>
</div>