<?php /* GDPress install */

////////////////////////////////////
////	Start of Install	////
////////////////////////////////////


global $wpdb, $wp_version;

$m = array();

if ( version_compare( $wp_version, $min_ver_wp , '<' ) )	$m[] = sprintf( __( 'Your %1$s version is \'%2$s\', at least version \'%3$s\' required.', 'GDPress' ), __( 'WordPress' ), $wp_version , $min_ver_wp );
if ( !function_exists( 'filter_input' ) )			$m[] = 		__( '"filter_input" php function is not available, ask your webhost technical support.', 'GDPress' );

////////////////////
////	1.0	////
////////////////////

if ( !is_dir( GDP_UPL_ABSPATH ) && !mkdir( GDP_UPL_ABSPATH ) ) 		$m[] = sprintf( __( 'The directory \'%1$s\' cannot be created.', 'GDPress' ), GDP_UPL_ABSPATH );
if (  is_dir( GDP_UPL_ABSPATH ) && !is_writable( GDP_UPL_ABSPATH ) ) 	$m[] = sprintf( __( 'The directory \'%1$s\' is not writable.', 'GDPress' ), GDP_UPL_ABSPATH );

//// ADVANCED ////

$advanced_path = 'advanced/' . get_current_blog_id() . '/';

if ( !is_dir( GDP_UPL_ABSPATH . $advanced_path ) )
{
	if ( is_dir( GDP_CONTENT_DIR . 'advanced' ) )
	{
		// mirroring the files for this blog
		$source = untrailingslashit( GDP_CONTENT_DIR . 'advanced' );
		$dest   = untrailingslashit( GDP_UPL_ABSPATH . $advanced_path );
		mkdir( $dest, 0777, true );
		foreach( $iterator = new \RecursiveIteratorIterator( new \RecursiveDirectoryIterator($source, \RecursiveDirectoryIterator::SKIP_DOTS), \RecursiveIteratorIterator::SELF_FIRST ) as $item )
		{
			if ($item->isDir()) 	mkdir( $dest . '/' . $iterator->getSubPathName(), 0777, true );
			else 			copy( $item, $dest . '/' . $iterator->getSubPathName() );
		}
	}
}

//// end of ADVANCED ////

if ( !empty( $m ) )
{
	$plugin = filter_input( INPUT_GET, 'plugin' );
	$err  = sprintf( __( '<b>Sorry, but you can\'t run this plugin : %1$s. </b>', 'GDPress' ), $plugin );
	$err .= '<ol><li>' . implode( '</li><li>', $m ) . '</li></ol>';

	if ( isset( $plugin ) ) deactivate_plugins( $plugin );	
	trigger_error( $err, E_USER_ERROR );
	return false;
}

////////////////////
////	2.0	////
////////////////////

$charset_collate = $wpdb->get_charset_collate();

$gdp_tables = "CREATE TABLE $wpdb->gdp_events (
 id bigint(20) unsigned NOT NULL AUTO_INCREMENT,
 created timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Created Timestamp (Timezoned on insert)',
 request_time bigint(20) NOT NULL DEFAULT '0' COMMENT 'Request Time (Unix timestamp on insert)',
 event varchar(255) NOT NULL DEFAULT '' COMMENT 'Event name',
 related varchar(255) NOT NULL DEFAULT '' COMMENT 'Event related to (software component or data subject)',
 family varchar(255) NOT NULL DEFAULT '' COMMENT 'Event family (core, mu-plugin, plugin, theme or empty for data subject',
 data_subject tinyint(1) NOT NULL DEFAULT '0' COMMENT 'If to be retrieved to the Data Subject (boolean)',
 wp_user_id bigint(20) NOT NULL DEFAULT '0' COMMENT 'WordPress User ID (0 if unknown)',
 ip varchar(255) NOT NULL DEFAULT '' COMMENT 'Event related Ip adress',
 agent varchar(255) NOT NULL DEFAULT '' COMMENT 'Event useragent (empty if initiated by local site)',
 uri longtext COMMENT 'Event Uri generated (could be wp-cron)',
 info longtext COMMENT 'Event info (format specific to event name)',
 PRIMARY KEY (id),
 KEY related (related)
) $charset_collate;
CREATE TABLE $wpdb->gdp_eventmeta (
 meta_id bigint(20) unsigned NOT NULL auto_increment,
 gdp_event_id bigint(20) unsigned NOT NULL default '0',
 meta_key varchar(255) NOT NULL default '',
 meta_value longtext,
 PRIMARY KEY (meta_id),
 KEY gdp_event_id (gdp_event_id),
 KEY meta_key (meta_key)
) $charset_collate";

require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
dbDelta( $gdp_tables );

/////// Initialize GDP Dashboard

$option_name = GDP_Dashboard_Widget::option_wdgts;
$options = get_option( $option_name );
if ( !$options )
{
	$options = array();

	$w_keys = array( 'gdpress_dashboard', 'gdpress_dashboard_2', 'gdpress_dashboard_3' );

	$a = GDP_EU_Authorities::getInstance();

	if ( $a->get_authority_id() != 'EU' )
	{
		$feeds = $a->get_authority_feeds();
		if ( $feeds && count( $feeds ) ) 
		{
			$max = 6;
			if ( count( $feeds ) > $max ) $feeds = array_slice( $feeds, 0, $max );
			$nb_feeds = count( $feeds ) + 3;
			$k = array_shift( $w_keys );
			$options[$k] = array ( 'wtitle' => __( 'Your D.P.A.', 'GDPress' ), 'image' => false, 'maxfeeds' => $nb_feeds, 'caching' => '43200', 'maxlines' => '10', 'height' => '20', 'feeds' => $feeds );
		}
	}
	$k = array_shift( $w_keys );
	$options[$k] = array ( 'wtitle' => 'E.D.P.S./E.D.P.B.', 'image' => false, 'maxfeeds' => '5', 'caching' => '43200', 'maxlines' => '10', 'height' => '20', 'feeds' => array ( 0 => 'https://edps.europa.eu/feed/news_en',  1 => 'https://edpb.europa.eu/feed/news_en', ) );

	update_option( $option_name, $options );

	global $gdp_general;
	$gdp_general = get_option( GDPress::option_name_general );
	$gdp_general['dashboard_widgets'] = count( $options );
	update_option( GDPress::option_name_general, $gdp_general );
}

////////////////////////////
////	End of Install	////
////////////////////////////