<?php

if ( !( function_exists( 'current_user_can' ) && current_user_can( GDP_AdminPage::capability ) ) ) die( 'Access denied' );

global $wpdb, $gdp_general;

//
// MANAGING H1
//

$h1 = __( 'GDPress Settings', 'GDPress' );

//
// MANAGING TABS
//

$divs = array();

$_tabs = GDP_AdminPage::get_tabs();

$tab_active = $gdp_general['tab'] ?? 'general';

if ( isset( GDP_AdminPage::$pst_['_tab'] ) )
{
	$no_error = true;
	$message = false;

	$gdp_general['tab'] = $tab_active = GDP_AdminPage::$pst_['_tab'];

	update_option( GDPress::option_name_general, $gdp_general );

	$file = 'settings/' . GDP_AdminPage::$pst_['_tab'] . '/update.php';
	include( $file );

	if ( !empty( GDP_AdminPage::$err_mess ) ) 
	{
		foreach( GDP_AdminPage::$err_mess as $message ) break;
		$no_error = false;
	}
}
else
{
	$parms = GDP_AdminPage::get_url_parms( array( 'tab' ) );
	if ( !empty( $parms ) && isset( $parms['tab'] ) )
	{
		$tab_active = $parms['tab'];
	}
}
?>
<div class="wrap">
	<h1>
		<?php echo esc_html( $h1 ); ?>
	</h1>
<?php if ( isset( $message ) ) GDP_AdminPage::message( $message, $no_error ); ?>
	<div id="settings-tabs">
		<ul>
<?php 
	$i = $i_tab = 0;
	foreach( $_tabs as $_tab => $desc )
	{
		if ( $tab_active == $_tab ) $i_tab = $i;
		echo "\t\t\t" . '<li class="gdp_tab"><a href="#fragment-' . $_tab . '" title="' . esc_attr( $desc ) . '"><span class="button-secondary">' . $desc . '</span></a></li>' . "\n";
		$i++;
	}
	wp_localize_script( GDPress_page_settings, 'GDP_AdminPage_var', array( 'the_tab' => $i_tab, 'the_tab_name' => $tab_active ) );
?>
		</ul>
<?php
	foreach( $_tabs as $_tab => $desc )
	{
?>
		<div class="fragments" id="fragment-<?php echo $_tab; ?>" data-tab="<?php echo $_tab; ?>">
<?php 
		$file = 'settings/' . $_tab . '/form.php';
		include( $file );
?>
		</div>
<?php
	}
?>
	</div>
</div>