<?php // apis

if ( !isset( $apis ) ) $apis = get_option( GDPress::option_name_apis );

?>
<form name="<?php echo basename(__DIR__); ?>" method="post" class="gdp_settings">
	<input type="hidden" name="_tab" value="<?php echo basename(__DIR__); ?>" />
	<table class="form-table">

<!-- api.wordpress.org -->
		<tr>
			<th><?php _e( 'api.wordpress.org', 'GDPress' ); ?></th>
			<td class="field">
				<input type="checkbox" name="apis[events_news]" id="apis_events_news"<?php checked( isset( $apis['events_news'] ) ); ?> />
				<label for="apis_emojis"><?php _e( 'Remove widget \'WordPress Events and News\' from Dashboard', 'GDPress' ); ?></label>
			</td>
		</tr>

<!-- Emojis -->
		<tr>
			<th><?php _e( 'Emojis', 'GDPress' ); ?></th>
			<td class="field">
<?php
if ( get_option( 'use_smilies' ) == '1' ) 	_e( 'You currently allow emoticon convertion on your site (see help).', 'GDPress');
else 						_e( 'You have currently disabled the emoticon convertion option (see help).', 'GDPress');
?>
				<br /><br />

				<input type="checkbox" name="apis[emojis]" id="apis_emojis"<?php checked( isset( $apis['emojis'] ) ); ?> />
				<label for="apis_emojis"><?php _e( 'Remove emoticon conversion by GDPress', 'GDPress' ); ?></label>
			</td>
		</tr>

<!-- Avatars -->
		<tr>
			<th><?php _e( 'Avatars', 'GDPress' ); ?></th>
			<td class="field">
<?php
if ( get_option( 'show_avatars' ) ) 	_e( 'You currently allow avatars to be displayed on your site (see help).', 'GDPress');
else 					_e( 'You have currently disabled the "allow avatars" option   (see help).', 'GDPress');
?>
				<br /><br />

				<input type="checkbox" name="apis[avatars]" id="apis_avatars"<?php checked( isset( $apis['avatars'] ) ); ?> />
				<label for="apis_avatars"><?php _e( 'Remove Avatars from this settings <a href="options-discussion.php#show_avatars" target="_new_blank">page</a>', 'GDPress' ); ?></label>
			</td>
		</tr>


<!-- xmlrpc -->
		<tr>
			<th><?php _e( 'xmlrpc', 'GDPress' ); ?></th>
			<td class="field">
				<input type="checkbox" name="apis[xmlrpc]" id="apis_xmlrpc"<?php checked( isset( $apis['xmlrpc'] ) ); ?> />
				<label for="apis_xmlrpc"><?php _e( 'Disable xmlrpc', 'GDPress' ); ?></label>
			</td>
		</tr>

<!-- Rest_Api -->
		<tr>
			<th><?php _e( 'Rest Api', 'GDPress' ); ?></th>
			<td class="field">
				<input type="checkbox" name="apis[rest-api]" id="apis_rest_api"<?php checked( isset( $apis['rest-api'] ) ); ?> />
				<label for="apis_rest_api"><?php _e( 'Restrict access to logged people only', 'GDPress' ); ?></label>
			</td>
		</tr>
		<tr>
			<th><label for="apis_rest_url_prefix"><?php _e( 'Rename Rest Url Prefix', 'GDPress' ); ?></label></th>
			<td class="field<?php if ( isset( GDP_AdminPage::$err_mess['rest-url-prefix'] ) ) echo ' form-invalid'; ?>">
				<input type="text" size="10" name="apis[rest_url_prefix]" id="apis_rest_url_prefix" value="<?php echo ( isset( $apis['rest_url_prefix'] ) ) ? esc_attr( $apis['rest_url_prefix'] ) : ''; ?>" class="regular-text ltr<?php if ( isset( GDP_AdminPage::$err_mess['rest_url_prefix'] ) ) echo ' form-invalid'; ?>"<?php disabled( !isset( $apis['rest-api'] ) ); ?> />
				<br /><span class="italic"><?php _e( 'one word [a-zA-Z0-9_-], wordpress default is "wp-json"', 'GDPress'); ?></span>
			</td>
		</tr>

<!-- Heartbeat -->
		<tr>
			<th><hr /><?php _e( 'Heartbeat', 'GDPress' ); ?></th>
			<td class="field" style="padding-top: 20px;">
				<hr />
				<input type="checkbox" name="apis[heartbeat]" id="apis_heartbeat"<?php checked( isset( $apis['heartbeat'] ) ); ?> />
				<label for="apis_heartbeat"><?php _e( 'Disable Heartbeat', 'GDPress' ); ?></label>
			</td>
		</tr>

<?php do_action( 'GDPress_settings_apis_form' ); ?>

	</table>

<?php GDP_AdminPage::save_button(); ?>

</form>