<?php // embed

if ( !isset( $embed ) ) $embed = get_option( GDPress::option_name_embed );

$embed = $embed ?: array( 'remove-all' => false, ); // for 1st call

$embed_modes = array ( '0' => __( 'revoke', 'GDPress' ), '1' => __( 'authorized', 'GDPress' ), ); 

$Embed_handlers = GDP_WP_Embed_handlers::getInstance();
$handlers = $Embed_handlers::$_handlers;

ksort( $handlers );

$disabled = disabled( $embed['remove-all'], true, false );

$columns = array (
			'cb'		=> '',
			'title' 	=> __( 'Handler', 'GDPress' ),
			'regex' 	=> __( 'Regular Expression', 'GDPress' ),
			'callback' 	=> __( 'Callback', 'GDPress' ),
);

$hout = '';
$id = true;
foreach ( $columns as $key => $display_name ) 
{
	$tag  = ( 'cb' === $key ) ? 'td' : 'th';
	$thid = ( $id ) ? ' id="' . $key . '"' : '';

	$classes = 'manage-column column-' . $key;
	$classes .= ( 'cb' === $key ) ? ' check-column' : '';
	$classes .= ( 'title' === $key ) ? ' column-primary' : '';
	$class = ' class="' . $classes . '"';

	$attributes = '';
	$attributes .= ( 'title' === $key ) ? ' scope="col"' : '';

	$hout .= '<' . $tag . $thid . $class . $attributes . '>' . $display_name . '</' . $tag . '>';
};
$fout = '';
$id = false;
foreach ( $columns as $key => $display_name ) 
{
	$tag  = ( 'cb' === $key ) ? 'td' : 'th';
	$thid = ( $id ) ? ' id="' . $key . '"' : '';

	$classes = 'manage-column column-' . $key;
	$classes .= ( 'cb' === $key ) ? ' check-column' : '';
	$classes .= ( 'title' === $key ) ? ' column-primary' : '';
	$class = ' class="' . $classes . '"';

	$attributes = '';
	$attributes .= ( 'title' === $key ) ? ' scope="col"' : '';

	$fout .= '<' . $tag . $thid . $class . $attributes . '>' . $display_name . '</' . $tag . '>';
};

$out = '';

$out .= '<th>' . __( 'Handlers', 'GDPress' ) . '</th>';
$out .= '<td>';
$out .= '<table class="wp-list-table widefat fixed striped zyxw">';
$out .= '<thead>';
$out .= '<tr>';
$out .= $hout;
$out .= '</tr>';
$out .= '<tbody id="the-handler-list" class="list:handler">';

$had_handlers = $count_handlers = 0;

foreach ( $handlers as $k => $v )
{
	ksort( $v );

	foreach( $v as $kk => $vv )
	{
		$count_handlers++;

		$id = $k . '_' . $kk;

		$old_mode = $embed['handlers'][$k][$kk] ?? 0;
		$mode = ( $embed['remove-all'] ) ? 1 : $old_mode;

		$tr_class = ( !$mode ) ? '' : ' disabled';

		$out .= '<tr class="gdpr_embed' . $tr_class . '" id="gdpr_embed_' . esc_attr( $id ) . '">';
		foreach ( $columns as $column_name => $column_display_name ) 
		{
			$attributes = sprintf( 'class="%1$s column-%1$s"', $column_name );

 			switch ( $column_name ) 
			{
				case 'cb':
					if ( $mode == 1 ) $had_handlers++;

					$out .= '<th class="check-column">';
					$out .= ' <input type="checkbox" name="embed[handlers][' . $k . '][' . $kk . ']" id="embed_handler_' . $id . '" class="embed_handler" value="1" data-value="' . $old_mode . '" data-handler="' . esc_attr( $id ) . '"' . checked( $mode, 1, false ) . $disabled . ' />';
					$out .= '</th>';
				break;
				case 'title' :
					$attributes = 'class="handler-title column-handler-title"';
					$out .= '<td ' . $attributes . '><label for="embed_handler_' . $id . '">';
					$out .= "[$k] $kk";
					$out .= '</label></td>';
				break;
				case 'regex' :
					$out .= '<td ' . $attributes . '><code>';
					$out .= $vv['regex'];
					$out .= '</code></td>';
				break;
				case 'callback' :
					$out .= '<td ' . $attributes . '>';
					$out .= ( is_array( $vv['callback'] ) ) ? '(' . implode( ', ', $vv['callback'] ) . ')' : $vv['callback'];
					$out .= '</td>';
				break;
			}
		}
		$out .= '</tr>';
	}
}
$out .= '</tbody>';
$out .= '<tfoot>';
$out .= '<tr>';
$out .= $fout;
$out .= '</tr>';
$out .= '</tfoot>';
$out .= '</table>';
$out .= "\r\n";
$out .= '<input type="hidden" name="embed[had-handlers]"   value="' . $had_handlers   . '" />';
$out .= '<input type="hidden" name="embed[count-handlers]" value="' . $count_handlers . '" />';
$out .= "\r\n";

?>
<form name="<?php echo basename(__DIR__); ?>" method="post" class="gdp_settings">
	<input type="hidden" name="_tab" value="<?php echo basename(__DIR__); ?>" />
	<table class="form-table">

<!-- Embed -->
		<tr>
			<th><label for="embed_remove_all"><?php _e( 'Remove All', 'GDPress' ); ?></label></th>
			<td>
				<input type="checkbox" name="embed[remove-all]" id="embed_remove_all"<?php checked( $embed['remove-all'] ?? false ); ?> />
			</td>
		</tr>
		<tr>
<?php echo $out; ?>
		</tr>
	</table>

<?php GDP_AdminPage::save_button(); ?>

</form>