<?php // oembed

if ( !isset( $oembed ) ) $oembed = get_option( GDPress::option_name_oembed );

$oembed = $oembed ?: array( 'remove-all' => false, ); // for 1st call

$oembed_modes = array ( '9' => __( 'html', 'GDPress' ), '6' => __( 'image (if any)', 'GDPress' ), '3' => __( 'text (if any)', 'GDPress' ), '1' => __( 'url', 'GDPress' ), '0' => __( 'remove', 'GDPress' ), ); 

$oEmbed_providers = GDP_WP_oEmbed_providers::getInstance();
$providers = $oEmbed_providers::$_providers;

ksort( $providers );

$col = 4;
$item = 1;
$row = $col * $item;
$i = $j = $td = $tr = $alt = 0;

$out = '';

$disabled = disabled( $oembed['remove-all'], true, false );
$alternate = '';

foreach ( $providers as $k => $v )
{
	$id   = $v['id'];
	$icon = $v['icon'];
	$name = $v['name'];

	$old_mode = $oembed['providers'][$id]['mode'] ?? 9;
	$mode = ( $oembed['remove-all'] ) ? 0 : $old_mode;

	$td_class = ( $mode ) ? '' : ' disabled';

	$designation = ( is_string( $icon ) ) ? '<span class="gdpr_oembed_icon">' . $icon . '</span><span class="gdpr_oembed_name">' . $name . '</span><br />' : '<span class="gdpr_oembed_name">' . $name . '</span><br />';

	if ( intval ( $i/$row ) == $i/$row ) 
	{
		$alt++;
		$tr = true; 
		$td = 0;

		$out .= '<tr' . $alternate . '>';
		$out .= ( $i == 0 ) ? '<th>' . __('Providers', 'GDPress' ) . '</th>' : '<th></th>';
	}
	if ( intval ( $j/$item ) == $j/$item )
	{
		$out .= '<td class="gdpr_oembed' . $td_class . '" id="gdpr_oembed_' . $id . '">';
		++$td;
	}

	$out .= '<label for="oembed_provider_' . $id . '_mode">';
	$out .= $designation;
	$out .= '<span>';
	$out .= '<select name="oembed[providers][' . $id . '][mode]" id="oembed_provider_' . $id . '_mode" class="oembed_provider_mode" data-value="' . $old_mode . '" data-provider="' . $id . '"' . $disabled . '>';
	$out .= GDP_AdminPage::select_option( $oembed_modes, $mode, false );
	$out .= '</select></span></label>';

	$j++;
	if ( intval ( $j/$item ) == $j/$item ) $out .= '</td>';
	$i++;
	if ( intval ( $i/$row ) == $i/$row ) { $out .= '</tr>'; $tr = false; }
}
if ( intval ( $j/$item ) != $j/$item )
{
	$out .= '</td>'; 
	while ( $td < $item ) { $out .= '<td></td>'; ++$td;}
}
if ( intval ( $i/$row ) != $i/$row ) $out .= '</tr>';
$out .= "\n";

?>
<form name="<?php echo basename(__DIR__); ?>" method="post" class="gdp_settings">
	<input type="hidden" name="_tab" value="<?php echo basename(__DIR__); ?>" />
	<table class="form-table">

<!-- oEmbed -->
		<tr>
			<th><label for="oembed_remove_all"><?php _e( 'Remove All', 'GDPress' ); ?></label></th>
			<td colspan="<?php echo $col; ?>">
				<input type="checkbox" name="oembed[remove-all]" id="oembed_remove_all"<?php checked( $oembed['remove-all'] ?? false ); ?> />
			</td>
		</tr>

<?php echo $out; ?>

	</table>

<?php GDP_AdminPage::save_button(); ?>

</form>