<?php // site_health

if ( !isset( $site_health ) ) $site_health = get_option( GDPress::option_name_site_health );

$site_health = $site_health ?: array( 'remove-all' => false, ); // for 1st call

$site_health_modes = array ( '0' => __( 'revoke', 'GDPress' ), '1' => __( 'authorized', 'GDPress' ), ); 

$Site_Health_tests = GDP_WP_Site_Health_tests::getInstance();
$tests = $Site_Health_tests::$_tests;

ksort( $tests );

$disabled = disabled( $site_health['remove-all'], true, false );

$columns = array (
			'cb'	=> '',
			'label'	=> __( 'Label', 'GDPress' ),
			'id' 	=> __( 'Id', 'GDPress' ),
			'test' 	=> __( 'Test', 'GDPress' ),
			'status'=> __( 'Status', 'GDPress' ),
);
$primary_col = 'label';
$hout = '';
$id = true;
foreach ( $columns as $key => $display_name ) 
{
	$tag  = ( 'cb' === $key ) ? 'td' : 'th';
	$thid = ( $id ) ? ' id="' . $key . '"' : '';

	$classes = 'manage-column column-' . $key;
	$classes .= ( 'cb' === $key ) ? ' check-column' : '';
	$classes .= ( $primary_col === $key ) ? ' column-primary' : '';
	$class = ' class="' . $classes . '"';

	$attributes = '';
	$attributes .= ( 'id' === $key ) ? ' scope="col"' : '';

	$hout .= '<' . $tag . $thid . $class . $attributes . '>' . $display_name . '</' . $tag . '>';
};
$fout = '';
$id = false;
foreach ( $columns as $key => $display_name ) 
{
	$tag  = ( 'cb' === $key ) ? 'td' : 'th';
	$thid = ( $id ) ? ' id="' . $key . '"' : '';

	$classes = 'manage-column column-' . $key;
	$classes .= ( 'cb' === $key ) ? ' check-column' : '';
	$classes .= ( $primary_col === $key ) ? ' column-primary' : '';
	$class = ' class="' . $classes . '"';

	$attributes = '';
	$attributes .= ( $primary_col === $key ) ? ' scope="col"' : '';

	$fout .= '<' . $tag . $thid . $class . $attributes . '>' . $display_name . '</' . $tag . '>';
};

$out = '';

$out .= '<th>' . __( 'Tests', 'GDPress' ) . '</th>';
$out .= '<td>';
$out .= '<table class="wp-list-table widefat fixed striped zyxw">';
$out .= '<thead>';
$out .= '<tr>';
$out .= $hout;
$out .= '</tr>';
$out .= '<tbody id="the-test-list" class="list:test">';

$had_tests = $count_tests = 0;

foreach ( $tests as $k => $v )
{
	ksort( $v );

	foreach( $v as $kk => $vv )
	{
		$count_tests++;

		$id = $k . '_' . $kk;

		$old_mode = $site_health['tests'][$k][$kk] ?? 0;
		$mode = ( $site_health['remove-all'] ) ? 1 : $old_mode;

		$tr_class = ( !$mode ) ? '' : ' disabled';

		$out .= '<tr class="gdpr_site_health' . $tr_class . '" id="gdpr_site_health_' . esc_attr( $id ) . '">';
		foreach ( $columns as $column_name => $column_display_name ) 
		{
			$attributes = sprintf( 'class="%1$s column-%1$s"', $column_name );

 			switch ( $column_name ) 
			{
				case 'cb':
					if ( $mode == 1 ) $had_tests++;

					$out .= '<th class="check-column">';
					$out .= ' <input type="checkbox" name="site_health[tests][' . $k . '][' . $kk . ']" id="site_health_test_' . $id . '" class="site_health_test" value="1" data-value="' . $old_mode . '" data-test="' . esc_attr( $id ) . '"' . checked( $mode, 1, false ) . $disabled . ' />';
					$out .= '</th>';
				break;
				case 'id' :
					$attributes = 'class="test-id column-test-id"';
					$out .= '<td ' . $attributes . '><label for="site_health_test_' . $id . '">';
					$out .= $kk;
					$out .= '</label></td>';
				break;
				case 'test' :
					$out .= '<td ' . $attributes . '><code>';
					$out .= ( is_array( $vv['test'] ) ) ? '(' . implode( ', ', $vv['test'] ) . ')' : $vv['test'];
					$out .= '</code></td>';
				break;
				case 'status' :
					$out .= '<td ' . $attributes . '>';
					$out .= $k;
					$out .= '</td>';
				break;
				default :
					$out .= '<td ' . $attributes . '>';
					$out .= $vv[$column_name];
					$out .= '</td>';
				break;
			}
		}
		$out .= '</tr>';
	}
}
$out .= '</tbody>';
$out .= '<tfoot>';
$out .= '<tr>';
$out .= $fout;
$out .= '</tr>';
$out .= '</tfoot>';
$out .= '</table>';
$out .= "\r\n";
$out .= '<input type="hidden" name="site_health[had-tests]"   value="' . $had_tests   . '" />';
$out .= '<input type="hidden" name="site_health[count-tests]" value="' . $count_tests . '" />';
$out .= "\r\n";
?>
<form name="<?php echo basename(__DIR__); ?>" method="post" class="gdp_settings">
	<input type="hidden" name="_tab" value="<?php echo basename(__DIR__); ?>" />
	<table class="form-table">

<!-- Site Health -->
		<tr>
			<th><label for="site_health_remove_all"><?php _e( 'Remove All', 'GDPress' ); ?></label></th>
			<td>
				<input type="checkbox" name="site_health[remove-all]" id="site_health_remove_all"<?php checked( $site_health['remove-all'] ?? false ); ?> />
			</td>
		</tr>
		<tr>
<?php echo $out; ?>
		</tr>
	</table>

<?php GDP_AdminPage::save_button(); ?>

</form>