/* dashboard_widget */

var gdp_dashboard_widget = {

	widget : function( i )
	{
		this.init = function( i )
		{
			this.i = i;

			this.storage = '';

			this.has_content = false;
			this.has_control = false;

			this.is_content  = true;

			this.id = ( this.i == 1 ) ? 'gdpress_dashboard' : 'gdpress_dashboard_'+this.i;

			this.widget 	= 'div#'+this.id;

			this.wtitle     = this.widget + ' span.wtitle';
			jQuery( this.wtitle ).after( GDP_RssWidgetL10n.handlers );

			this.wtitle_hide= '#'+this.id+'-hide';

			this.configure 	= this.widget + ' a.edit-box.open-box';
			this.cancel 	= this.widget + ' a.edit-box.close-box';
			this.spinner 	= this.widget + ' a.edit-box.spin';

			this.inside 	= this.widget + ' div.inside';
			this.cache 	= this.widget + ' div.cache';
			this.form 	= this.inside + ' form';
			this.norequest 	= this.inside + ' .widget-norequest';

			jQuery( this.widget ).append('<div class="cache hidden"></div>');

			jQuery( this.configure ).click( function() {
				jQuery( this ).hide();
				_this.display_control();
				return false;
			});

			jQuery( this.cancel ).click( function() {
				jQuery( this ).hide();
				jQuery( _this.norequest ).removeClass( 'widget-norequest' );
				_this.no_change();
				return false;
			});

			this.get_content();
			this.get_control();
		};

		this.get_content = function()
		{
			if ( jQuery( this.norequest ).length ) return;					// in case there is nothing to look for !

			var parms = { action: 'gdp_ajax', gdp_action: 'dbp_get_content', i: this.i };

			jQuery.ajax({
				data: parms,
				type: "POST",
				url: ajaxurl,
				success: function( data ) { _this.got_content( data ); } 
			});
		};

		this.got_content = function( data )
		{
			var target = (this.is_content) ? this.inside : this.cache;

			if ( (typeof data.empty !=='undefined') && data.empty )
			{
				jQuery( target ).html( jQuery( '#tmpl-dbp-nocontent' ).html() );	// reset widget content (with (no)data)
			}
			else
			{
				var content = wp.template( 'dbp-content' );
				jQuery( target ).html( content( data ) );

				this.set_status( 'has_content', true );
			}
		};

		this.get_control = function()
		{
			var parms = { action: 'gdp_ajax', gdp_action: 'dbp_get_control', i: this.i };

			jQuery.ajax({
				data: parms,
				type: "POST",
				url: ajaxurl,
				success: function( data ) { _this.got_control( data ); } 
			});
		};

		this.got_control = function( data )
		{
			var target = (this.is_content) ? this.cache : this.inside;

			if ( data )
			{
				var control = wp.template( 'dbp-control' );
				jQuery( target ).html( control( data ) );

				this.set_status( 'has_control', true );
			}
		};

		this.display_control = function()
		{
			this.set_status( 'is_content', false );

			this.flip_viewport();

			jQuery( this.form ).on( 'submit', function() {
				jQuery( _this.form + ' input[type="submit"]' ).attr( 'disabled', 'disabled' );
				jQuery( _this.wtitle      ).html( jQuery( _this.form + " input[name='" + _this.id + "[wtitle]']").val() );
				jQuery( _this.wtitle_hide ).next( 'span.wtitle' ).html( jQuery( _this.form + " input[name='" + _this.id + "[wtitle]']").val() );
				var form = jQuery( this );
				_this.control_submitted( form );
				return false;
			});

			jQuery( this.form + " input[name='" + this.id + "[image]']").change( function() {
				if (this.checked) { alert( GDP_RssWidgetL10n.images );	}
			});
		};

		this.no_change = function()
		{
			this.flip_viewport();

			this.set_status( 'is_content', true );
		};

		this.control_submitted = function( form )
		{
			this.set_status( 'has_control', false );
			this.set_status( 'has_content', false );
			this.set_status( 'is_content', true );

			this.flip_viewport();

			var parms = { action: 'gdp_ajax', gdp_action: 'dbp_control_submitted', i: this.i, form: jQuery( form ).serialize() };

			jQuery.ajax({
				data: parms,
				type: "POST",
				url: ajaxurl,
				success: function( data ) {
					jQuery( _this.norequest ).removeClass( 'widget-norequest' ); 
					_this.got_content( data );
					_this.get_control();
				} 
			});
		};

		this.flip_viewport = function()
		{
			this.storage = jQuery( this.inside ).html();
			jQuery( this.inside ).html( jQuery( this.cache ).html() );
			jQuery( this.cache ).html( this.storage );
		};

		this.set_status = function( s, b )
		{
			if ( s == 'has_control' ) this.has_control = b;
			if ( s == 'has_content' ) this.has_content = b;
			if ( s == 'is_content'  ) this.is_content = b;

			jQuery( this.configure ).hide();
			jQuery( this.cancel    ).hide();
			jQuery( this.spinner   ).hide();

			if (this.has_control && this.has_content)
			{
				(this.is_content) ? jQuery( this.configure ).show() : jQuery( this.cancel ).show();
			}
			else
			{
				if (this.has_content)
				{
					jQuery( this.spinner ).show();
				}
				else
				{
					if (this.has_control)
					{
						(this.is_content) ? jQuery( this.configure ).show() : jQuery( this.cancel ).show();
					}
					else
					{
						jQuery( this.spinner ).show();
					}
				}
			}
		};


		var _this = this;			// _this is this ( oop ! )

		this.init( i );
	},

	init : function()
	{
		// creating widget instances
		for( i = 1; i <= GDP_RssWidgetL10n.count; i++ ) new gdp_dashboard_widget.widget( i );
	}
};
jQuery( document ).ready( function() { gdp_dashboard_widget.init(); } );