<?php
class GDP_AdminPage extends GDP_WP_Admin_page_
{
	const screen		= GDPress_page_settings;
	const capability	= 'GDPress_manage_options';
	const help_url		= '#';
	const file		= __FILE__;

	public static $first = true;

	public static $err_mess = array();

//// Help ////

	public static function add_help_tab() 
	{
		global $current_screen;

		$_tabs = self::get_tabs();

		foreach( $_tabs as $_tab => $desc )
		{
			$content = '';

			$file = 'includes/settings/' . $_tab . '/help.php';
			include( $file );

			$current_screen->add_help_tab( array( 'id' => $_tab, 'title' => $desc, 'content' => $content ) );
		}
	}

////  Styles  ////

	public static function print_styles( $s ) 
	{
		$styles = ( is_array( $s ) ) ? $s : array();

		wp_register_style( self::screen, '/' . GDP_PATH . 'gp-admin/css/settings.css' );
		$styles[] = self::screen;

		parent::print_styles( $styles );
	}


////  Scripts  ////

	public static function print_scripts( $scripts = array() ) 
	{
		wp_register_script( self::screen, 	'/' . GDP_PATH . 'gp-admin/js/settings.js', array( 'jquery-ui-tabs' ), NULL, 1 );
		wp_localize_script( self::screen, 'GDP_AdminPageL10n', array( 'requestFile' => admin_url( 'admin-ajax.php' ) ) );
		$scripts[] = self::screen;

		parent::print_scripts( $scripts );
	}

////  Misc  ////

	public static function get_tabs()
	{
		global $gdp_general;

		$_tabs['general'] = __( 'General', 'GDPress' );
		$_tabs['apis']    = __( "API's",   'GDPress' );
		$_tabs['embed']   = __( 'Embed',   'GDPress' );
		$_tabs['oembed']  = __( 'oEmbed',  'GDPress' );
		$_tabs['site_health']  = __( 'Site&nbsp;Health',  'GDPress' );
		$_tabs['headers']  = __( 'Mails',  'GDPress' );

		if ( $gdp_general || isset( GDP_AdminPage::$pst_['general'] ) )
		{
			$_tabs = apply_filters( 'GDPress_settings_tab', $_tabs );
		}

		return $_tabs;
	}

	public static function save_button()
	{
		$out  = '<p class="submit"><input type="submit" name="Submit" class="button-primary" value="' . esc_attr( __( 'Save Changes' ) ) . '" /></p>' . "\r\n";

		echo $out;
	}
}