<?php

class GDP_Dashboard
{
	const maxwidgets = 9;

	function __construct() 
	{
	// for metaboxes
		new GDP_Dashboard_metaboxes();

	// for widget(s)
		$this->get_count();
		if ( !$this->count ) return;

	// for css
		$this->print_styles();

	// for js
		$this->print_scripts();

	// for templates
		add_action( 'admin_footer', array( &$this, 'admin_footer' ) );

	// creating widget instances
		for ( $i = 1; $i <= $this->count ; $i++ ) new GDP_Dashboard_Widget( $i );
	}

	function get_count() 
	{
		global $gdp_general;

		$this->count = ( isset( $gdp_general['dashboard_widgets'] ) && is_numeric( $gdp_general['dashboard_widgets'] )) ? $gdp_general['dashboard_widgets'] : 1;
	}

	function print_styles()
	{
		$pathcss	= GDP_ABSPATH    . 'gp-admin/css/colors_' . get_user_option( 'admin_color' ) . '.css';
		$css		= '/' . GDP_PATH . 'gp-admin/css/colors_' . get_user_option( 'admin_color' ) . '.css';
		$css_def	= '/' . GDP_PATH . 'gp-admin/css/colors_fresh.css';
		$css		= ( is_file( $pathcss ) ) ? $css : $css_def;
		wp_register_style( __CLASS__ . '_colors', 	$css );

		wp_register_style( __CLASS__ , '/' . GDP_PATH . 'gp-admin/css/dashboard_widget.css', array( __CLASS__ . '_colors' ) );
		wp_enqueue_style( __CLASS__ );
	}

	function print_scripts()
	{
		wp_register_script( __CLASS__ , '/' . GDP_PATH . 'gp-admin/js/dashboard_widget.js', array( 'jquery', 'wp-util' ) );
		wp_localize_script( __CLASS__ , 'GDP_RssWidgetL10n', array(
			'count'		=> $this->count,
			'handlers' 	=> esc_js( sprintf( '<span class="postbox-title-action"><a href="#" class="edit-box spin" %3$s></a><a href="#" class="edit-box open-box" %3$s>%1$s</a><a href="#" class="edit-box close-box" %3$s>%2$s</a></span>', __( 'Configure', 'GDPress' ), __( 'Cancel', 'GDPress' ), 'style="display:none;"' ) ),
			'images' 	=> sprintf( esc_js( __( 'By activating this option, you are informed that %1$simages from external sites will be displayed. %1$sThis process can collect personal data. %1$sRemember to update your RoPA accordingly. %1$sRegards', 'GDPress' ) ), "\r\n" ),
		));
		wp_enqueue_script( __CLASS__ );
	}

	function admin_footer() 
	{
		require_once( GDP_ABSPATH . 'gp-admin/includes/templates/dashboard_footer.php' );
	}

	public static function update_option( $option_name, $newvalue ) 
	{
		return update_option( $option_name, $newvalue );
	}
}