<?php
class GDP_Download
{
	/**
	 * Request id
	 *
	 * @static string
	 */
	public static $_request_id = null;

	/**
	 * To download the result of the export
	 *
	 * This way is more secure 
	 *
	 * if for some reasons, the Chief Of Privacy or dpo decide to destroy the request,
	 *
	 * then the file cannot be downloaded ...
	 *
	 * making the upload directories less visible ( privacy by design to avoid potential data breach ! )
	 *
	 */

	function __construct() 
	{
		$gdprivacy = $_GET['gdprivacy'];

		$parms = explode( '.', $gdprivacy );

		self::$_request_id = (int) array_pop( $parms );
 		
		$this->obscura = implode( '.', $parms );

		$this->request = wp_get_user_request( self::$_request_id );

		if ( $this->request )
		{
			$this->archive_url      = get_post_meta( self::$_request_id, '_export_file_url', true );
			$this->archive_pathname = get_post_meta( self::$_request_id, '_export_file_path', true );

			if ( is_file( $this->archive_pathname ) && strpos( $this->archive_pathname, $this->obscura ) && $this->process() )
			{
				$this->function = __FUNCTION__;
				$this->archive( 'downloaded' );
			}
			elseif( $this->archive_url && strpos( $this->archive_url, $this->obscura ) )
			{
				$this->function = __FUNCTION__;
				$this->archive( 'downloading_fallback' );
				wp_redirect( $this->archive_url );
			}
			else
			{
				$this->function = __FUNCTION__;
				$this->archive( 'downloading_failed' );
			}
		}
		wp_die();
	}

	function process() 
	{
		$this->function = __FUNCTION__;
		$this->archive( 'downloading', __FUNCTION__ );

		if( !$handle = @fopen( $this->archive_pathname, 'r' ) ) return false;

		header("Cache-Control: ");	# leave blank to avoid IE errors
		header("Pragma: ");		# leave blank to avoid IE errors
		header("Content-type: application/octet-stream");
		header('Content-Disposition: attachment; filename="' . basename( $this->archive_pathname ) . '"');
		header("Content-length:".(string)( filesize( $this->archive_pathname ) ) );

		// cleaning up the place
		while ( ob_get_level() ) { ob_end_clean(); }

		// neat and pretty before making your entrance
		sleep(1);

		// go !
		fpassthru( $handle );

		// and wash your hands !
		flush();

		return true;
	}

	function archive( $event, $data_subject = true, $info = array(), $email = null ) 
	{
		GDP_Event::insert( $event, $data_subject, array( 'metas' => array( 'func' => array( 'name' => $this->function, 'args' => array( 'url' => $this->archive_url ?? '', 'path' => $this->archive_pathname ?? '' ), ), ), ) );
	}
}