<?php
class GDP_EU_Authorities
{
	/**
	 * Unique class instance
	 *
	 * @static object
	 */
	private static $_instance = null;

	/**
	 * Array of authorities
	 *
	 */
	static $_authorities = array();

	/**
	 * Authority
	 *
	 */
	static $_authority = array();

	/**
	 * Lang
	 *
	 */
	static $_lang = array();

	/**
	 * Constructor
	 *
	 * Constructor is private, use getInstance() static function instead
	 */

	private function __construct()
	{
		$l = GDP_EU_Languages::getInstance();
		self::$_lang = $l->get_language_lang();

		require_once( GDP_ABSPATH . 'gp-includes/class/options/EU/authorities.php' );

		$timezone_string = get_option( 'timezone_string' );

		self::$_authority = ( $timezone_string && isset( self::$_authorities[$timezone_string] ) ) ? self::$_authorities[$timezone_string] : self::$_authorities['EU'];
		self::$_authority['id'] = ( $timezone_string && isset( self::$_authorities[$timezone_string] ) ) ? $timezone_string : 'EU';
	}

	public function get_authority( $id = false ) 
	{
		if ( $id ) return ( isset( self::$_authorities[$id] ) ) ? self::$_authorities[$id] : false;
		return self::$_authority;
	}

	public function get_authority_id() 
	{
		return self::$_authority['id'];
	}

	public function get_authority_desc() 
	{
		return self::$_authority['desc'];
	}

	public function get_authority_site() 
	{
		return self::$_authority['site']; // can be an array !
	}

	public function get_all_links() 
	{
		$links = array();

		$current = 0;

		foreach( self::$_authorities as $id => $authority )
		{
			if ( is_array( $authority['site'] ) )
			{
				foreach( $authority['site'] as $k => $v )
				{
					if ( ( self::$_authority['id'] == $id ) && ( self::$_lang == $k ) ) $current = $authority['alpha_order'][$k];
					$links[$authority['alpha_order'][$k]] = array(
						'link' => sprintf( '<a href="%1$s" target="_blank">%2$s</a>', $authority['site'][$k], $authority['desc'][$k] ),
						'flag' => $authority['flag'],
					);
				}
			}
			else
			{
				if ( self::$_authority['id'] == $id ) $current = $authority['alpha_order'];

				$links[$authority['alpha_order']] = array( 
					'link' => sprintf( '<a href="%1$s" target="_blank">%2$s</a>', $authority['site'], $authority['desc'] ),
					'flag' => $authority['flag'],
				);
			}
		}

		ksort( $links );

		return array( $links, $current );
	}

	public function get_authority_feeds( $authority = NULL ) 
	{
		if ( !isset( $authority ) ) $authority = self::$_authority;

		return ( is_array( $authority['rss'] ) ) ? $authority['rss'] : array( $authority['rss'] );
	}

	public static function getInstance()
	{
 		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}

		return self::$_instance;
	}
}