<?php
class GDP_EU_Languages
{
	/**
 	 * Unique class instance
	 *
	 * @static object
 	 */
	private static $_instance = null;

	/**
 	 * Array of EU Languages
	 *
 	 */
	static $_languages = array();

	/**
 	 * Language
	 *
 	 */
	static $_language = array();

	/**
 	 * Constructor
 	 *
 	 * Constructor is private, use getInstance() static function instead
 	 */

	private function __construct()
	{
		/** WordPress Translation Installation API */
		require_once ABSPATH . 'wp-admin/includes/translation-install.php';
		$translations = wp_get_available_translations();

		require_once( GDP_ABSPATH . 'gp-includes/class/options/EU/languages.php' );

		global $locale;

		$lang = substr( $locale, 0, 2 );

		$in_eu = ( isset( self::$_languages[$lang] ) ) ? $lang : false;

		$lang = ( $in_eu ) ? $lang : 'en';

		$desc = ( isset( self::$_languages[$lang] ) && isset( $translations[self::$_languages[$lang]] ) ) ? $translations[self::$_languages[$lang]]['native_name'] : self::$_languages[$lang];

		self::$_language = array( 'lang' => $lang, 'is_eu' => $in_eu, 'desc' => $desc ); 
	}

	public function get_language() 
	{
		return self::$_language;
	}

	public function get_language_lang() 
	{
		return self::$_language['lang'];
	}

	public function get_language_in_eu() 
	{
		return self::$_language['in_eu'];
	}

	public function get_language_desc() 
	{
		return self::$_language['desc'];
	}

	public static function getInstance()
	{
 		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}

		return self::$_instance;
	}
}