<?php
class GDP_Mail_Headers
{
	/**
	 * Options
	 *
	 * @static array
	 */
	private static $_options = null;

	const headers = array(
		'from' 		=> 'From',
		'bcc' 		=> 'Bcc',
		'return_path' 	=> 'Return-Path',
		'reply_to' 	=> 'Reply-To',
	);

	public function __construct()
	{
		self::$_options = get_option( GDPress::option_name_headers );

		if ( !isset( self::$_options['headers'] ) ) return;

		add_filter( 'user_request_action_email_headers', 	array( __CLASS__, 'set_headers' ), 999, 5 );
		add_filter( 'user_request_confirmed_email_headers', 	array( __CLASS__, 'set_headers' ), 999, 5 );
		add_filter( 'wp_privacy_personal_data_email_headers', 	array( __CLASS__, 'set_headers' ), 999, 5 );
		add_filter( 'user_erasure_complete_email_headers', 	array( __CLASS__, 'set_headers' ), 999, 5 );
	}

	public static function set_headers( $headers, $subject, $content, $request_id, $email_data )
	{
		if ( ! ( $request = wp_get_user_request( $request_id ) ) ) return;
		if ( ! in_array( $request->action_name, _wp_privacy_action_request_types() ) ) return;

		$name = self::$_options['name'];

		foreach( self::$_options['headers'] as $header => $value )
		{
			$sprintf = ( $header == 'return_path' ) ? '%1$s: <%2$s>' : '%1$s: %3$s <%2$s>';

			$header = sprintf( $sprintf, self::headers[$header], self::$_options['email'], $name );

			if ( is_string( $headers ) ) $headers = $header . "\n" . $headers;
			elseif ( is_array( $headers ) ) $headers = array_merge( array( $header ), $headers );
		}

		return $headers;
	}
}