<?php
class GDP_Request
{
	public static function template( $file )
	{
		if ( empty( $file ) )
		{
			$file = '/gdpress.php';
		}

		$requester = wp_get_current_commenter();

		$comment_author = '';

		$comment_author_email = $requester['comment_author_email'];

		$comment_author_url = '';

		defined( 'GDPRESS_TEMPLATE' ) or define( 'GDPRESS_TEMPLATE' , true );

		$theme_template = STYLESHEETPATH . $file;

		$include = apply_filters( 'gdpress_template', $theme_template );

		switch( true )
		{
			case ( file_exists( $include ) ) :
				require_once( $include );
			break;
			case ( file_exists( TEMPLATEPATH . $file ) ) :
				require_once( TEMPLATEPATH . $file );
			break;
			default :
				echo '<!-- GDPress - start - default gdpress template -->' . "\r\n";
				echo '<div id="comments" class="comments-area">' . "\r\n";
				self::form();
				echo '</div>' . "\r\n";
				echo '<!-- GDPress - end   - default gdpress template -->' . "\r\n";

			break;
		}
	}

	public static function form( $args = array(), $post_id = NULL )
	{
		$get_ = filter_input_array( INPUT_GET );

		$post_id = $post_id ?? get_the_ID();

		$requester     = wp_get_current_commenter();
		$user          = wp_get_current_user();
		$user_identity = $user->exists() ? $user->display_name : '';

		$args = wp_parse_args( $args );
		if ( ! isset( $args['format'] ) ) 
		{
			$args['format'] = current_theme_supports( 'html5', 'comment-form' ) ? 'html5' : 'xhtml';
		}

		$req      = true;
		$html_req = ( $req ? " required='required'" : '' );
		$html5    = 'html5' === $args['format'];
		$fields   = array(
			'email' 		=> '<p class="comment-form-email"><label for="email">' . __( 'Email' ) . ( $req ? ' <span class="required">*</span>' : '' ) . '</label> ' .
						 '<input id="email" name="email" ' . ( $html5 ? 'type="email"' : 'type="text"' ) . ' value="' . esc_attr( $requester['comment_author_email'] ) . '" size="30" maxlength="100" aria-describedby="email-notes"' . $html_req . ' /></p>',
		);

		$required_text = ' ' . __( 'All fields required.', 'GDPress' );

		$fields   = apply_filters( 'gdpress_form_default_fields', $fields );

		$defaults = array(
			'fields' 		=> $fields,

			'gdpress_field' => '<p class="comment-form-url"><label for="request">{{label_gdpress_field}}' . ( $req ? ' <span class="required">*</span>' : '' ) . '</label>' . self::get_select() . '</p>'
							   . '<p class="comment-form-url" style="display:none;"><label for="url">' . __( 'Website' ) . '</label> <input id="url" name="url" ' . ( $html5 ? 'type="url"' : 'type="text"' ) . ' value="" size="30" maxlength="200" /></p>',

			'logged_in_as' 	=> '<p class="logged-in-as">' . sprintf(
					/* translators: 1: edit user link, 2: accessibility text, 3: user name, 4: logout URL */
									__( '<a href="%1$s" aria-label="%2$s">Logged in as %3$s</a>. <a href="%4$s">Log out?</a>' ),
					get_edit_user_link(),
					/* translators: %s: user name */
										esc_attr( sprintf( __( 'Logged in as %s. Edit your profile.' ), $user_identity ) ),
					$user_identity,
					wp_logout_url( apply_filters( 'the_permalink', get_permalink( $post_id ), $post_id ) )
					) . '</p>',
			'gdpress_notes_before' => '<p class="comment-notes"><span id="email-notes">' . __( 'Your privacy matters, your email address will not be published.', 'GDPress' ) . '</span>' . ( $req ? $required_text : '' ) . '</p>',
			'gdpress_notes_after'  => '',
			'action'               => admin_url( 'admin-ajax.php' ),
			'id_form'              => 'commentform',
			'id_submit'            => 'submit',
			'class_form'           => 'comment-form',
			'class_submit'         => 'submit',
			'name_submit'          => 'submit',
			'format'               => 'xhtml',

			'title_reply_before'   => '<h3 id="reply-title" class="comment-reply-title">',
			'title_reply_after'    => '</h3>',
			'submit_button'        => '<input name="%1$s" type="submit" id="%2$s" class="%3$s" value="%4$s" />',
			'submit_field'         => '<br /><p class="form-submit">%1$s %2$s</p>',

			'title_reply'          => __( 'Post a Request', 'GDPress' ),
			'title_success'        => __( 'Please check your email.', 'GDPress' ),
			'label_gdpress_field'  => __( 'Personal data request', 'GDPress' ),
			'label_submit'         => __( 'Post Request', 'GDPress' ),
		);

		$args = wp_parse_args( $args, apply_filters( 'gdpress_form_defaults', $defaults ) );

		$args = array_merge( $defaults, $args );

		$args['gdpress_field'] = str_replace( '{{label_gdpress_field}}', $args['label_gdpress_field'], $args['gdpress_field'] );

		do_action( 'gdpress_form_before' );

		$is_valid = self::is_valid(); /* are we just coming from a new gdpress request ? */

		$out = '';

		$out .= '	<div id="respond" class="comment-respond">';

		$out .= $args['title_reply_before'];
		$out .= ( !$is_valid ) ? $args['title_reply'] : $args['title_success'];
		$out .= $args['title_reply_after'];

		if ( !$is_valid )
		{
			$out .= '<form action="' . esc_url( $args['action'] ) . '" method="post" id="' . esc_attr( $args['id_form'] ) . '" class="' . esc_attr( $args['class_form'] ) . '"' . ( ( $html5 ) ? ' novalidate' : '' ) . '>';

			do_action( 'gdpress_form_top' );

			if ( is_user_logged_in() )
			{
				$out .= apply_filters( 'gdpress_form_logged_in', $args['logged_in_as'], $requester, $user_identity );
				do_action( 'gdpress_form_logged_in_after', $requester, $user_identity );
			}
			else
			{
				$out .= $args['gdpress_notes_before'];
			}

			$gdpress_fields = (array) $args['fields'] + array( 'gdprequest' => $args['gdpress_field'] );

			$gdpress_fields = apply_filters( 'gdpress_form_fields', $gdpress_fields );

			$gdpress_field_keys = array_diff( array_keys( $gdpress_fields ), array( 'gdprequest' ) );

			$first_field = reset( $gdpress_field_keys );
			$last_field  = end( $gdpress_field_keys );

			foreach ( $gdpress_fields as $name => $field )
			{
				if ( 'gdprequest' === $name )
				{
					$out .= apply_filters( 'gdpress_form_field_request', $field );
					$out .= $args['gdpress_notes_after'];
				}
				elseif ( ! is_user_logged_in() )
				{
					if ( $first_field === $name )
					{
						do_action( 'gdpress_form_before_fields' );
					}

					$out .= apply_filters( "gdpress_form_field_{$name}", $field ) . "\n";

					if ( $last_field === $name )
					{
						do_action( 'gdpress_form_after_fields' );
					}
				}
			}

			$submit_button = sprintf(
				$args['submit_button'],
				esc_attr( $args['name_submit'] ),
				esc_attr( $args['id_submit'] ),
				esc_attr( $args['class_submit'] ),
				esc_attr( $args['label_submit'] )
			);

			$submit_button = apply_filters( 'gdpress_form_submit_button', $submit_button, $args );

			$submit_field = sprintf(
				$args['submit_field'],
				$submit_button,
				''
			);

			$out .= apply_filters( 'gdpress_form_submit_field', $submit_field, $args );

			do_action( 'gdpress_form' );

			$out .= '<input type="hidden" name="referredby" value="' . esc_url( get_the_permalink() ) . '" />';
			$out .= '<input type="hidden" name="gdp_action" value="request_form" />';
			$out .= '<input type="hidden" name="action"     value="gdpress_form" />';

			$out .= '		</form>';
		}

		$out .= ( !$is_valid ) ? '	</div><!-- #respond -->' : '	</div><!-- #' . $is_valid . ' -->';

		echo $out;

		do_action( 'gdpress_form_after' );
	}

	public static function handle_submission( $request_data )
	{
		if ( isset( $request_data['author'] ) )
		{
			return self::WP_Error();
		}

		if ( isset( $request_data['email'] ) && is_string( $request_data['email'] ) )
		{
			$request_data_email = trim( $request_data['email'] );
		}

		$user = wp_get_current_user();
		if ( $user->exists() )
		{
			$request_data_email = $user->user_email;
		}

		if ( ! ( isset( $request_data['url'] ) && empty( $request_data['url'] ) ) )
		{
			return self::WP_Error();
		}

		if ( isset( $request_data['comment'] ) )
		{
			return self::WP_Error();
		}

		if ( isset( $request_data['comment_parent'] ) )
		{
			return self::WP_Error();
		}

		if ( isset( $request_data['request'] ) && is_string( $request_data['request'] ) )
		{
			$request_data_request = trim( $request_data['request'] );
		}
		else
		{
			$request_data_request = false;
		}

		if ( ! is_email( $request_data_email ) )
		{
			return new WP_Error( 'require_valid_email', __( '<strong>ERROR</strong>: please enter a valid email address.' ), 200 );
		}

		if ( ! in_array( $request_data_request, _wp_privacy_action_request_types() ) )
		{
			return self::WP_Error();
		}

		$request_id = self::new_( $request_data_email, $request_data_request, true ); 

		switch(true)
		{
			case ( is_wp_error( $request_id ) ) :
				return new WP_Error( 'invalid_request', $request_id->get_error_message(), 200 );
			break;
			case ( ! $request_id ) :
				return new WP_Error( 'aborted_request', esc_html__( 'We have a problem with your request. Please contact the administrator.', 'GDPress' ) , 200 );
			break;
			default :
				wp_send_user_request( $request_id );
			break;
		}

		wp_redirect( add_query_arg( array( 'gdprequest' => $request_data_request, 'r' => $request_id ), $request_data['referredby'] ) . '#respond' );
	}

	public static function new_( $request_data_email, $request_data_request, $avoid_die = false )
	{
		do_action( 'preprocess_gdpress_request', $request_data_email, $request_data_request );

		$request_approved = self::allow( $request_data_email, $request_data_request, $avoid_die );
		if ( is_wp_error( $request_approved ) ) 
		{
			return $request_approved;
		}

		return wp_create_user_request( $request_data_email, $request_data_request );
	}

	public static function allow( $request_data_email, $request_data_request, $avoid_die )
	{
		do_action( 'gdpress_check_flood', $request_data_email, $request_data_request, $avoid_die );

		$is_flood = apply_filters( 'gdpress_is_flood', false, $request_data_email, $request_data_request, $avoid_die );

		if ( $is_flood )
		{
			$gdpress_flood_message = apply_filters( 'gdpress_flood_message', __( 'You are posting requests too quickly. Slow down.', 'GDPress' ) );
			return new WP_Error( 'gdpress_flood', $gdpress_flood_message, 429 );
		}

		$approved = apply_filters( 'pre_gdpress_approved', true, $request_data_email, $request_data_request );
		return $approved;
	}

	public static function is_flood( $is_flood, $request_data_email, $request_data_request, $avoid_die = false )
	{
		global $wpdb;

		if ( true === $is_flood )
		{
			return $is_flood;
		}

		if ( ( current_user_can( GDPress::$const['export']['cap'] ) ) && ( GDPress::$const['export']['post_name'] == $request_data_request ) )
		{
			return false;
		}

		if ( ( current_user_can( GDPress::$const['remove']['cap'] ) ) && ( GDPress::$const['remove']['post_name'] == $request_data_request ) )
		{
			return false;
		}

		$hour_ago = gmdate( 'Y-m-d H:i:s', time() - HOUR_IN_SECONDS );

		if ( is_user_logged_in() )
		{
			$user         = get_current_user_id();
			$check_column = '`post_author`';
		}
		else
		{
			$user         = $request_data_email;
			$check_column = '`post_title`';
		}

		$sql = $wpdb->prepare(
			"SELECT `post_date_gmt` FROM `$wpdb->posts` WHERE `post_date_gmt` >= %s AND $check_column = %s AND post_status = %s ORDER BY `post_date_gmt` DESC LIMIT 1",
			$hour_ago,
			$user,
			$request_data_request 
		);

		$lasttime = $wpdb->get_var( $sql );
		if ( $lasttime )
		{
			$time_lastrequest = mysql2date( 'U', $lasttime, false );
			$time_newrequest  = mysql2date( 'U', $date, false );
			$flood_die = apply_filters( 'gdpress_flood_filter', false, $time_lastrequest, $time_newrequest );
			if ( $flood_die ) 
			{
				do_action( 'gdpress_flood_trigger', $time_lastcomment, $time_newcomment );
				if ( true === $avoid_die )
				{
					return true;
				}
				else
				{
					$gdpress_flood_message = apply_filters( 'gdpress_flood_message', __( 'You are posting requests too quickly. Slow down.', 'GDPress' ) );

					if ( defined( 'GDP_DOING_AJAX' ) && GDP_DOING_AJAX )
					{
						die( $gdpress_flood_message );
					}
					wp_die( $gdpress_flood_message, 429 );
				}
			}
		}

		return false;
	}

	public static function throttle_flood( $block, $time_lastcomment, $time_newcomment )
	{
		if ( $block )
		{
			return $block;
		}

		if ( ( $time_newcomment - $time_lastcomment ) < 15 )
		{
			return true;
		}

		return false;
	}

	public static function is_valid()
	{
		$get_ = filter_input_array( INPUT_GET );
		$post_name = $get_['gdprequest'] ?? false;
		$ID        = $get_['r'] ?? false;

		if ( !$post_name ) 
		{
			return false;
		}

		if ( !in_array( $post_name, _wp_privacy_action_request_types() ) ) 
		{
			return false;
		}

		if ( !$ID ) 
		{
			return false;
		}

		if ( !is_numeric( $ID ) ) 
		{
			return false;
		}

		global $wpdb;
		return $wpdb->get_var( $wpdb->prepare( "SELECT ID FROM {$wpdb->posts} WHERE ID = %d AND post_type = 'user_request' AND post_status = 'request-pending' AND post_name = %s;", $ID, $post_name ) );
	}

	public static function get_select( $options = array() )
	{
		$defaults = array( 	'id'			=> 'request',
						'export_class'	=> 'export_celadon',
						'remove_class'	=> 'remove_pink',
		 );

		$options  = wp_parse_args( $options, $defaults );
		extract( $options );

		return '<select id="' . $id . '" name="request">'
			   . '<option value="' . GDPress::$const['export']['post_name'] . '" class="' . $export_class . '" >' . GDPress::$const['export']['desc'] . '</option>'
			   . '<option value="' . GDPress::$const['remove']['post_name'] . '" class="' . $remove_class . '" >' . GDPress::$const['remove']['desc'] . '</option>'
			. '</select>';
	}

////	being fooled ? be fool ! ////

	public static function WP_Error( $code = NULL )
	{
		$wp_errors = array(	'comment_id_not_found'  => array( 'message' => '', 'data' => '', ),
						'comment_closed'        => array( 'message' => __( 'Sorry, comments are closed for this item.' ), 'data' => 403, ),
						'comment_on_trash'      => array( 'message' => '', 'data' => '', ),
						'comment_on_draft'      => array( 'message' =>  __( 'Sorry, comments are not allowed for this item.' ), 'data' => 403, ),
						'comment_on_password_protected' => array( 'message' => '', 'data' => '', ),
						'not_logged_in'         => array( 'message' => __( 'Sorry, you must be logged in to comment.' ), 'data' => 403, ),
						'require_name_email'    => array( 'message' => __( '<strong>ERROR</strong>: please fill the required fields (name, email).' ), 'data' => 200, ),
						'require_valid_comment' => array( 'message' => __( '<strong>ERROR</strong>: please type a comment.' ), 'data' => 200, ),
						'comment_save_error'    => array( 'message' => __( '<strong>ERROR</strong>: The comment could not be saved. Please try again later.' ), 'data' => 500, ),
						'require_valid_comment' => array( 'message' => __( '<strong>ERROR</strong>: please type a comment.' ), 'data' => 200, ),
						'comment_save_error'    => array( 'message' => __( '<strong>ERROR</strong>: The comment could not be saved. Please try again later.' ), 'data' => 500, ),
		);
		if ( ( isset( $code ) ) && ( !isset( $wp_errors[$code] ) ) ) 
		{
			$code = NULL;
		}
		$code = $code ?? array_rand( $wp_errors );
		return new WP_Error( $code, $wp_errors[$code]['message'], $wp_errors[$code]['data'] );
	}
}