<?php
class GDP_WP_Admin_Menu
{
	function __construct()
	{
		$menus = array();

		foreach ( GDPress::capabilities() as $capability => $datas )
		{
			if ( isset( $datas['menu'] ) && $datas['menu'] && current_user_can( $capability ) )
			{
				$datas['capability'] 	= $capability;
				$menus[]		= $datas;
			}
		}
		if ( empty( $menus ) ) return;

		uasort( $menus, array( 'self', 'sort_menus' ) );

		$first = true;
		foreach ( $menus as $menu )
		{
			if ( !$menu['parent'] )
			{
				if ( $first )
				{
					$toplevel = $menu['page'];
					add_menu_page( '', __( 'GDPress', 'GDPress' ), $menu['capability'], $menu['page'], $menu['func'], 'dashicons-admin-gdpress' );
				}
				$first = false;
			}

			$parent = ( $menu['parent'] ) ? $menu['parent'] : $toplevel;
			add_submenu_page( $parent, $menu['page_title'], $menu['menu_title'], $menu['capability'], $menu['page'], $menu['func'] );
		}
	}

	public static function sort_menus( $a, $b ) 
	{
		return strcmp( $a['menu'], $b['menu'] );
	}
}