<?php
class GDP_WP_Ajax
{
	public static $get_;
	public static $pst_;
	public static $req_;

	private static $instance = null;

	function __construct()
	{
		if ( GDPress::is_bot() ) return;

		self::get_request();

		if ( !isset( self::$req_['gdp_action'] ) ) wp_die( -1 );

		$action = str_replace( '-', '_', self::$req_['gdp_action'] );

		if ( method_exists( __CLASS__, $action ) ) self::$action();
		else do_action( "gdp_action_{$action}" );

		die();
	}

	public static function get_request()
	{
		foreach( array( 'get_' => INPUT_GET, 'pst_' => INPUT_POST ) as $k => $v )
		{
			self::$$k = filter_input_array( $v );
			if ( is_null( self::$$k ) ) self::$$k = array();
		}
		self::$req_ = array_merge( self::$get_, self::$pst_ );
	}

	public static function request_form()
	{
		if ( 'POST' != filter_input( INPUT_SERVER, 'REQUEST_METHOD' ) )
		{
			$protocol = ( in_array( $protocol = filter_input( INPUT_SERVER, 'SERVER_PROTOCOL' ), array( 'HTTP/1.1', 'HTTP/2', 'HTTP/2.0' ) ) ) ? $protocol : 'HTTP/1.0';
			header( 'Allow: POST' );
			header( "$protocol 405 Method Not Allowed" );
			header( 'Content-Type: text/plain' );
			exit;
		}
		nocache_headers();
		$request = GDP_Request::handle_submission( self::$pst_ );
		if ( is_wp_error( $request ) )
		{
			$data = intval( $request->get_error_data() );
			if ( empty( $data ) ) exit;
			wp_die( '<p>' . $request->get_error_message() . '</p>', __( 'Request Submission Failure', 'GDPress' ), array( 'response' => $data, 'back_link' => true, ) );
		}
	}

	public static function widget_form()
	{
		defined( 'GDP_DOING_AJAX' ) or define ( 'GDP_DOING_AJAX',	true );

		$request = GDP_Widget::handle_submission( self::$pst_ );

		if ( is_wp_error( $request ) )
		{
			wp_send_json_error( array( 'message' => $request->get_error_message(), 'id' => self::$pst_['id'] ) );
		}
		wp_send_json_success( array( 'message' => __( 'Please check your email.', 'GDPress' ), 'id' => self::$pst_['id'] ) );
	}

////// GDPress dashboard

	function dbp_get_content()
	{
		$i = $_POST['i'];
		$w = new GDP_Dashboard_Widget( $i );
		$w->get_content();
		die();
	}

	function dbp_get_control()
	{
		$i = $_POST['i'];
		$w = new GDP_Dashboard_Widget( $i );
		$w->get_control();
		die();
	}

	function dbp_control_submitted()
	{
		$i = $_POST['i'];
		$w = new GDP_Dashboard_Widget( $i );
		$w->control_submitted();
		$w->get_content();
		die();
	}

////// GDPress RoPA

	function gdp_get_ropa()
	{
		$related = $_POST['related'];
		$family  = $_POST['family'];

		$data = new stdClass();

		$data->related = $related;
		$data->family  = $family;
		$data->events  = GDP_Event::get_events( $related, $family );

		wp_send_json( $data );
		die();
	}


	public static function getInstance()
	{
		if ( !isset( self::$instance ) ) self::$instance = new self();
		return self::$instance;
	}
}