<?php
class GDP_WP_Role_COP
{
	const cop = 'GDPress_c.o.p.'; // c.o.p. stands for Chief Of Privacy

	const capabilities = array(
		self::cop,

		'export_others_personal_data',

		'erase_others_personal_data',
		'delete_users',

		'manage_options',
		'manage_privacy_options',
		'edit_pages',
	);

	const remove_sub_menus = array(
		'options-general.php' => array(
			'options-general.php',
			'options-media.php',
			'options-permalink.php',
			'options-reading.php',
			'options-writing.php',
			'options-discussion.php',
		),
	);

	public static function add()
	{
		self::remove();

		$subscriber   = get_role( 'subscriber' );
		$capabilities = $subscriber->capabilities;

		foreach( self::capabilities as $capability )
		{
			$capabilities[$capability] = true;
		}
		foreach ( GDPress::capabilities() as $capability => $v )
		{
			$capabilities[$capability] = true;
		}

		add_role( self::cop, __( 'Data Protection Officer', 'GDPress' ), $capabilities );
	}

	public static function remove()
	{
		remove_role( self::cop );
	}

// admin
	public static function is_only()
	{
		$current_user = wp_get_current_user();
		return ( array_intersect( array( self::cop ) , $current_user->roles ) );
	}

	public static function admin_menu() // wp roles and capabilities are not RACF (sigh !)
	{
		foreach( self::remove_sub_menus as $k => $v )
		{
			foreach( $v as $vv )
			{
				remove_submenu_page( $k, $vv );
			}
		}
	}

}