<?php
class GDP_WP_off_Rest_Api
{
	const hooks = array(
		'template_redirect' 	=> array( 'func' => 'remove_action', 'call' => 'rest_output_link_header',  'priority' => 11, ),
		'wp_head' 		=> array( 'func' => 'remove_action', 'call' => 'rest_output_link_wp_head', 'priority' => 10, ),
		'xmlrpc_rsd_apis' 	=> array( 'func' => 'remove_action', 'call' => 'rest_output_rsd', ),
	);

	const errors = array(
		'https://www.google.com',
		'https://www.wordpress.org',
		'https://s.w.org',
		'https://goo.gl',
	);

	function __construct() 
	{
		foreach( self::hooks as $hook => $f )
		{
			extract( $f );
			$func( $hook, $call, $priority ?? 10 );
			unset( $priority );
		}

		add_filter( 'rest_authentication_errors', 	array( __CLASS__, 'rest_authentication_errors' ) );
		add_filter( 'rest_url_prefix', 			array( __CLASS__, 'rest_url_prefix' ) );
	}

	public static function rest_authentication_errors( $a )
	{
		if ( is_user_logged_in() ) return $a;
		wp_redirect( self::errors[array_rand( self::errors )] );
	}

	public static function rest_url_prefix( $p )
	{
		global $gdp_general;

		$rest_url_prefix = ( isset( $gdp_general['rest-url-prefix'] ) ) ? $gdp_general['rest-url-prefix'] : '';
 
		return ( empty( $rest_url_prefix ) ) ? $p : $rest_url_prefix;
	}
}