<?php
class GDP_WP_off_Site_Health
{
	const events = array( 'wp_site_health_scheduled_check', );

	function __construct()
	{
		$this->options = get_option( GDPress::option_name_site_health );

		add_action( 'plugins_loaded', array( $this, 'plugins_loaded' ), 1000 );
	}

	public function plugins_loaded()
	{
		if ( !$this->options ) return;

		add_filter( 'site_status_tests', array( $this, 'site_status_tests' ), 1000, 1 );

		if ( $this->options['remove-all'] )
		{
			// info collector
			add_filter( 'debug_information', '__return_empty_array', 999, 1 );
	
			// transients
			/* as long as expiration is 0 ( no time out) */
			delete_option( '_transient_health-check-site-status-result' );

			// crons
			//foreach( self::events as $event ) { wp_unschedule_hook( $event ); wp_schedule_event( time() + 360 * DAY_IN_SECONDS, 'weekly', $event ); }
			add_filter( 'pre_schedule_event', array( $this, 'pre_schedule_event' ), 1000, 2 );

			// admin
			add_action( 'admin_menu', 		array( $this, 'admin_menu' ), 999 );
			add_action( 'wp_dashboard_setup', 	array( $this, 'wp_dashboard_setup' ), 999 );

			if ( is_admin() )
			{
				add_action( 'current_screen', 	array( $this, 'current_screen' ), 999 );
			}
		}
	}

	public function site_status_tests( $tests )
	{
		if ( !$this->options ) return;

		$t = ( $this->options['remove-all'] ) ? $tests : $this->options['tests'];

		foreach( $t as $k => $v )
		{
			foreach( $v as $kk => $vv )
			{
				unset( $tests[$k][$kk] );
			}
		}

		return $tests;
	}

// crons
	public function pre_schedule_event( $pre = NULL, $event )
	{
		return ( in_array( $event, self::events ) ) ? false : $pre;
	}

// admin
	public function admin_menu()
	{
		remove_submenu_page( 'tools.php', 'site-health.php' );
	}

	function wp_dashboard_setup()
	{
		if ( !function_exists( 'wp_add_dashboard_widget' ) ) return;

		wp_deregister_style( 'site-health' );
		wp_deregister_script( 'site-health' );

	// for filtering widgets
		global $wp_meta_boxes;

		$page = 'dashboard';
		$removable = array( 'dashboard_site_health' );	

		foreach ( array_keys( $wp_meta_boxes[$page]) as $context )
		{ 
			foreach ( array_keys( $wp_meta_boxes[$page][$context]) as $priority ) 
			{
				foreach ( $wp_meta_boxes[$page][$context][$priority] as $key => $box ) 
				{
					if ( in_array( $key, $removable ) ) unset( $wp_meta_boxes[$page][$context][$priority][$key] );
				}
			}
		}
	}

	public function current_screen()
	{
		$screen = get_current_screen();

		if ( 'site-health' != $screen->id ) return;

		wp_redirect( admin_url() );
		exit;
	}
}