<?php
abstract class GDP_dashboard_metabox_
{
	function __construct( $title )
	{
		$this->title = $title;

		add_filter( 'GDPress_dashboard_metaboxes_register', 	array( $this, 'register' ), 8, 1 );
		add_action( 'GDPress_dashboard_add_meta_box', 		array( $this, 'add_meta_box' ), 8, 1 );
	}

	function register( $metaboxes )
	{
		$metaboxes[$this->id]['title'] = $this->title;
		if ( isset( $this->parms ) ) $metaboxes[$this->id]['parms'] = $this->parms;
		ksort( $metaboxes );
		return $metaboxes;
	}

	function add_meta_box( $screen )
	{
		add_meta_box( 'gdpress' . $this->id . 'div', $this->title, array( $this, 'meta_box' ), $screen, $this->context, '' );
	}

	function format_links( $links, $lang = false )
	{
		$hr = '';

		$out = '<ul>';
		foreach( $links as $link )
		{
			if ( !is_array( $link ) ) { $hr = '<hr />'; continue; }
			$out.= '<li>' . $hr . sprintf( '<a href="%1$s" target="_blank">%2$s</a>', ( $lang ) ? sprintf( $link[0], $lang, strtoupper( $lang ) ) : $link[0], $link[1] ) . '</li>';
			$hr = '';
		}
		$out .= '</ul>';

		return $out;
	}
}