<?php
class GDP_Dashboard_metabox_authorities extends GDP_dashboard_metabox_
{
	var $id		= 'Authorities';
	var $context	= 'normal';
	var $file 	= __FILE__;

	function meta_box()
	{
		$headers = array();

		$a = GDP_EU_Authorities::getInstance();

		list( $authorities, $current ) = $a->get_all_links();

		$headers[0] = $authorities[0];
		$headers[1] = array(	'link' => sprintf( '<a href="%1$s" target="_blank">%2$s</a>', sprintf( 'https://edpb.europa.eu/about-edpb/board/members_%1$s', $a::$_lang ), __( 'European Data Protection Board', 'GDPress' ) ),
					'flag' => 'eu',
		);
		if ( $current ) $headers[$current] = $authorities[$current];
		unset( $authorities[0], $authorities[$current] );

		$out = '<ul>';
		foreach( $headers as $order => $authority )
		{
			$class = ( $order == $current ) ? ' class="current_authority"' : '';
			extract( $authority );
			$link = sprintf( $link, $a::$_lang );
			$out.= sprintf( '<li%1$s><div class="gdp_flag gdp_flag_%2$s"> </div>%3$s</li>', $class, $flag, $link );
		}
		$out .= '</ul>' . "\r\n";

		$out .= '<hr />';

		$out .= '<ul>';
		foreach( $authorities as $order => $authority )
		{
			$class = ( $order == $current ) ? ' class="current_authority"' : '';
			extract( $authority );
			$out.= sprintf( '<li%1$s><div class="gdp_flag gdp_flag_%2$s"> </div>%3$s</li>', $class, $flag, $link );
		}
		$out .= '</ul>' . "\r\n";

		echo $out;
	}
}
new GDP_Dashboard_metabox_authorities( __( 'E.U. - Data Protection Authorities', 'GDPress' ) );