<?php
class GDP_Dashboard_metabox_gdpr extends GDP_dashboard_metabox_
{
	var $id		= 'GDPR';
	var $context	= 'normal';
	var $file 	= __FILE__;

	function meta_box()
	{
		$links = array();
		$links[0] = array( 'https://ec.europa.eu/info/priorities/justice-and-fundamental-rights/data-protection/2018-reform-eu-data-protection-rules/eu-data-protection-rules_%1$s', __( 'Presentation', 'GDPress' ) );
		$links[1] = array( 'https://eur-lex.europa.eu/legal-content/%2$s/TXT/HTML/?uri=CELEX:32016R0679&from=%2$s', 	__( 'GDPR in your language', 'GDPress' ) );
		$links[2] = array( 'https://eur-lex.europa.eu/legal-content/EN/TXT/HTML/?uri=CELEX:32016R0679&from=EN', 	__( 'GDPR in English', 'GDPress' ) );
		$links[3] = array( 'https://eur-lex.europa.eu/legal-content/%2$s/TXT/?uri=CELEX%%3A32016R0679', 		__( 'GDPR in 24 languages', 'GDPress' ) );
		$links[4] = '';
		$links[97] = array( 'https://edpb.europa.eu/our-work-tools/public-consultations-art-704/2020/guidelines-082020-targeting-social-media-users_en', 'Guidelines 08/2020 on the targeting of social media users' );
		$links[98] = array( 'https://edpb.europa.eu/our-work-tools/public-consultations-art-704/2020/guidelines-072020-concepts-controller-and-processor_en', 'Guidelines 07/2020 on the concepts of controller and processor in the GDPR' );
		$links[99] = array( 'https://edpb.europa.eu/our-work-tools/our-documents/guidelines/guidelines-052020-consent-under-regulation-2016679_en', 'Guidelines 05/2020 on consent under Regulation 2016/679 [GDPR]' );
		$links[100] = array( 'https://edpb.europa.eu/search/site/2016/679_en?f%%5B0%%5D=bundle%%3Aedpb_publication', 'Other related guidelines' );

		$l = GDP_EU_Languages::getInstance();
		$lang = $l->get_language_lang();

		if ( $lang == 'en' ) unset( $links[1] );

		$out = $this->format_links( $links, $lang );

		echo $out;
	}
}
new GDP_Dashboard_metabox_gdpr( __( 'GDPR - General Data Protection Regulation', 'GDPress' ) );