<?php
class GDP_Dashboard_metabox_strategy_EU extends GDP_dashboard_metabox_
{
	var $id		= 'strategy_EU';
	var $context	= 'normal';
	var $file 	= __FILE__;

	function meta_box()
	{
		$hr = '';

		$links = array();
		$links[] = array( 'https://www.coe.int/%3$s/web/data-protection/home', 	__( 'Council of Europe | Data Protection website', 'GDPress' ) );
		$links[] = '';
		$links[] = array( 'https://edps.europa.eu/edps-strategy-2020-2024/',  	__( 'Shaping a safer digital future | The EDPS Strategy 2020-2024', 'GDPress' ) ); 
		$links[] = array( 'https://ec.europa.eu/digital-single-market/%1$s', 	__( 'Shaping Europe\'s digital future | Digital Economy & Society', 'GDPress' ) );
		$links[] = array( 'https://ec.europa.eu/info/strategy_%1$s', 		__( 'Strategy | European Commission', 'GDPress' ) );
		$links[] = array( 'https://ec.europa.eu/info/law_%1$s', 		__( 'Law | European Commission', 'GDPress' ) );
		
		$l = GDP_EU_Languages::getInstance();
		$lang = $l->get_language_lang();

		$coe_lang = ( !in_array( $lang,  array( 'en', 'es', 'fr' ) ) ) ? 'en' : $lang;

		$out = '<ul>';
		foreach( $links as $link )
		{
			if ( !is_array( $link ) ) { $hr = '<hr />'; continue; }
			$out.= '<li>' . $hr . sprintf( '<a href="%1$s" target="_blank">%2$s</a>', sprintf( $link[0], $lang, strtoupper( $lang ), $coe_lang ), $link[1] ) . '</li>';
			$hr = '';
		}
		$out .= '</ul>' . "\r\n";

		echo $out;
	}
}
new GDP_Dashboard_metabox_strategy_EU( __( 'E.U. - Digital Strategy', 'GDPress' ) );