<?php
if ( ( !current_user_can( 'export_others_personal_data' ) ) || ( !current_user_can( 'erase_others_personal_data' ) || !current_user_can( 'delete_users' ) ) ) return;
class GDP_Dashboard_metabox_wp_privacy extends GDP_dashboard_metabox_
{
	var $id		= 'wp_privacy';
	var $context	= 'side';
	var $file 	= __FILE__;

	function meta_box()
	{
		$out = '';

		$subsubsub = array();
		
		$actions = array();
		$text_actions = array(
			'none' 	=> __( 'None', 'GDPress' ),
			'miss' 	=> __( 'Missing', 'GDPress' ),
			'trash' => __( 'In trash', 'GDPress' ), 
			'change'=> __( 'Change', 'GDPress' ), 
			'edit' 	=> __( 'Edit', 'GDPress' ), 
			'view' 	=> __( 'View', 'GDPress' ), 
			'preview'=> __( 'Preview', 'GDPress' ), 
		);

		// logic from privacy settings page

		$ppp_id = (int) get_option( 'wp_page_for_privacy_policy' );

		if ( ! empty( $ppp_id ) )
		{
			$ppp = get_post( $ppp_id );

			if ( !$ppp instanceof WP_Post ) {
				$actions['miss'] = ( current_user_can( 'manage_privacy_options' ) ) ? admin_url( 'options-privacy.php' ) : NULL ;
			} elseif ( 'trash' === $ppp->post_status ) {
				$actions['trash'] = 'edit.php?post_status=trash&post_type=page';	
			} else {
				if ( current_user_can( 'manage_privacy_options' ) ) $actions['change'] = admin_url( 'options-privacy.php' );
				$actions['edit'] = add_query_arg( array( 'post' => $ppp_id, 'action' => 'edit', ), admin_url( 'post.php' ) );
				$action = ( 'publish' === get_post_status( $ppp_id ) ) ? 'view' : 'preview';
				$actions[$action] = get_permalink( $ppp_id );
			}
		}
		else
		{
			$actions['none'] = ( current_user_can( 'manage_privacy_options' ) ) ? admin_url( 'options-privacy.php' ) : NULL ;
		}

		$out .= '<ul class="gdp-subsubsub">';	

		$out .= '<li><b>' . __( 'Privacy Policy Page', 'GDPress' ) . '</b>';
		$out .= '<br />';

		foreach( $actions as $action => $link )	
		{
			$subsubsub['pps'][] = ( isset( $link ) ) ? sprintf( '<a href="%1$s">%2$s</a>', $link, $text_actions[$action] ) : $text_actions[$action];
		}
		$out .= implode( ' | ', $subsubsub['pps'] ) . '</li>';

		$subsubsub = array();

		// code from erase-personal-data & export-personal-data

		_wp_personal_data_cleanup_requests();

		$_list_table_args = array(
			'plural' 	=> 'privacy_requests',
			'singular' 	=> 'privacy_request',
		);

		if ( current_user_can( 'export_others_personal_data' ) )
		{
			$requests_table = _get_list_table( 'WP_Privacy_Data_Export_Requests_List_Table', $_list_table_args );
			$subsubsub['export'] = $requests_table->get_views();
		}

		if ( current_user_can( 'erase_others_personal_data' ) && current_user_can( 'delete_users' ) )
		{
			$requests_table = _get_list_table( 'WP_Privacy_Data_Removal_Requests_List_Table', $_list_table_args );
			$subsubsub['remove'] = $requests_table->get_views();
		}

		foreach ( $subsubsub as $action => $subs )
		{
			$out .= '<li><hr /><b>' . ucfirst( GDPress::$const[$action]['short'] ) . '</b><br />';
			$out .= implode( ' | ', $subs );
			$out .= '</li>';
		}
		$out .= '</ul>';

		echo $out;
	}
}
new GDP_Dashboard_metabox_wp_privacy( __( 'Site Privacy At a Glance', 'GDPress' ) );