<?php
class GDP_Dashboard_metabox_wp_wellness extends GDP_dashboard_metabox_
{
	var $id		= 'wp_wellness';
	var $context	= 'side';
	var $file 	= __FILE__;

	function __construct( $title )
	{
		add_filter( 'GDPress_scripts', array( $this, 'scripts' ), 8, 2 );
		parent::__construct( $title );
	}

	function scripts( $scripts )
	{
	// for javascript
		wp_register_script( __CLASS__, '/' . GDP_PATH . 'gp-admin/js/dashboard_wellness.js', array('jquery', 'clipboard'), false, 1 );
		wp_localize_script( __CLASS__, 	'gdp_dashboard_wellness_L10n', array(
			'ko' => esc_js( __( 'Select text and copy', 'GDPress' ) ) . "\n\n\n",
			'ok' => esc_js( __( 'Copied', 'GDPress' ) ),
		));
		$scripts[] = __CLASS__;

		return $scripts;
	}

	function meta_box()
	{
		$this->site_url = $this->get_site_url();

	// version wordpress
		global $wp_version, $wpdb;
		$txt[] = sprintf( __( '<strong>- WordPress version :</strong> %1$s%2$s', 'GDPress' ), $wp_version, ( is_multisite() ) ? ' ' . __( 'multi-site', 'GDPress' ) : '' );

	// version php/mysql
		$php_ver = phpversion();
		$mysql_ver = $wpdb->db_version();
		$txt[] = sprintf( __( '<strong>- PHP/MySQL version :</strong> %1$s / %2$s', 'GDPress' ), $php_ver, $mysql_ver );

	// theme
		if ( function_exists( 'wp_get_theme' ) )
		{
			$wp_theme = wp_get_theme( get_stylesheet() );
			$wp_theme_name = $wp_theme->display( 'Name', true, false );
			$wp_theme_url = $wp_theme->display( 'ThemeURI', true, false );
			if ( !empty( $wp_theme_url ) ) $wp_theme_url = sprintf( __( '<strong>- Theme URI :</strong> %s', 'GDPress' ), $wp_theme_url );
		}
		else
		{
			global $wp_themes;
			$wp_theme_name = get_current_theme();
			$wp_theme = $wp_themes[$wp_theme_name];
			$wp_theme_url = $wp_theme['Author URI'];
			if ( !empty( $wp_theme_url ) ) $wp_theme_url = sprintf( __('<strong>- Theme Author URI :</strong> %s', 'GDPress' ), $wp_theme_url );
		}
		$txt[] = sprintf( __( '<strong>- Theme used :</strong> %s', 'GDPress' ), $wp_theme_name );
		if ( !empty( $wp_theme_url ) ) 
			$txt[] = $wp_theme_url;

	// plugins
		foreach ( (array) get_plugins() as $plugin_file => $plugin_data ) 
		{
			if ( is_plugin_active_for_network( $plugin_file ) ) 
				$ms_plugins[] = $plugin_data['Name'] . ' (' . $plugin_data['Version'] . ')';
			elseif ( is_plugin_active( $plugin_file ) ) 
				$wp_plugins[] = $plugin_data['Name'] . ' (' . $plugin_data['Version'] . ')';
		}
		if ( isset( $wp_plugins ) )
			$txt[] = sprintf( __( '<strong>- Plugins :</strong> %s', 'GDPress' ), join( ', ', $wp_plugins ) );

		if ( isset( $ms_plugins ) )
			$txt[] = sprintf( __( '<strong>- Network Plugins :</strong> %s', 'GDPress' ), join( ', ', $ms_plugins ) );

	// site url
		$siteurl = $this->site_url;
		$txt[] = sprintf( __( '<strong>- Site url :</strong> %s', 'GDPress' ), $siteurl );

	// host
		$host = $_SERVER['SERVER_SOFTWARE'];
		$txt[] = sprintf( __( '<strong>- Webhost :</strong> %s', 'GDPress' ), $host );

	// os
	//	$os = php_uname();
	//	$txt[] = sprintf( __( '<strong>- O.S. :</strong> %s', 'GDPress' ), $os );

		$out = '';
		$out .= '<div id="gdp_dashboard_wellness_content"><strong class="hidden">' . __( 'Configuration :', 'GDPress' ) . '</strong>';
		$out .= "\n";
		$out .= '<ul><li>' . join( "</li>\n<li>", $txt ) . '</li></ul>';
		$out .= '</div>';
		$out .= '<div style="position:relative;">';
		$out .= '<div style="position:absolute;">';
		foreach( $txt as $k => $v ) $txt[$k] = strip_tags( $txt[$k] );
		$out .= '<textarea id="gdp_dashboard_wellness_copied" style="height:0; width:0; opacity:0;">' . __( 'Current configuration :', 'GDPress' ) . "\r\n" . join( "\r\n", $txt ) . '</textarea>';
		$out .= '</div>';

		$out .= '<div id="gdp_dashboard_wellness_button">';
		$out .= '<input id="gdp_dashboard_wellness_copy" class="gdp_dashboard_wellness_copy button-primary" type="button" data-clipboard-target="#gdp_dashboard_wellness_copied" value="' . esc_attr( __( 'Copy', 'GDPress' ) ) . '" />';
		$out .= '</div>';

		global $wpdb;
		$out .= '<!--' . print_r( array ( '$wpdb->blogid' => $wpdb->blogid, 'get_current_blog_id()' => get_current_blog_id() ), true ) . '-->';
		$out .= '</div>';

		echo $out;
	}

	function get_site_url()
	{
		return ( defined( 'WP_SITEURL' ) ) ? WP_SITEURL : site_url();
	}
}
new GDP_Dashboard_metabox_wp_wellness( __( 'Site Wellness', 'GDPress' ) );