<?php /* _gdpress */
if ( class_exists( 'GDPress' ) )
{
class GDP_WP_Privacy_exporter_gdpress extends GDP_WP_privacy_exporter_
{
	var $priority = 999;

	const per_page = 100;

	function exporter( $email, $page = 1 )
	{
		global $wpdb;

		/* */

		$start = ( $page - 1 ) * self::per_page;

		$events = $wpdb->get_results( $wpdb->prepare( "SELECT SQL_CALC_FOUND_ROWS * FROM $wpdb->gdp_events WHERE family = '' AND related = %s AND data_subject IS TRUE ORDER BY created, id LIMIT $start, " . self::per_page . ";", md5( $email ) ) );

		if ( !$events ) return $this->export;

		$total = $wpdb->get_var( "SELECT FOUND_ROWS()" );

		$current = $start + count( $events );

		/* */

		if ( $page == 1 )
		{
			$messages   = array();
			$messages[] = __( 'The events generated by the data subject request(s) and action(s) are archived under the responsability and authority of the dpo for legal purpose ONLY.', 'GDPress' );
			$messages[] = __( 'GDPR Chapter II - Principles, Article 5 - Principles relating to processing of personal data', 'GDPress' );
			$messages[] = __( 'GDPR Chapter II - Principles, Article 9 - Processing of special categories of personal data', 'GDPress' );
			$messages[] = __( 'GDPR Chapter IX - Provisions relating to specific processing situations', 'GDPress' );

			$data = array();
			foreach( $messages as $message )
			{
				$data[] = array( 'name' => __( 'Remarks', 'GDPress' ), 'value' => $message, );
			}				

			$this->export['data'][] = array(
				'group_id'    => 'gdp_events_info',
				'group_label' => __( 'GDPR Events > Remarks', 'GDPress' ),
				'item_id'     => "gdp_event-GDPR",
				'data'        => $data,
			);
		}

		/* */

		foreach ( (array) $events as $k => $event )
		{
			$events[$k]->info = maybe_unserialize( $events[$k]->info );
			$events[$k]->action_name = ( isset( $events[$k]->info['action'] ) ) ? $events[$k]->info['action'] : __( '(unknown)', 'GDPress' );
			unset( $events[$k]->info );
		}

		$properties = array(
			'created' 	=> __( 'Time of Event', 'GDPress' ),
			'id' 		=> __( 'Id', 'GDPress' ),
			'action_name'	=> __( 'Request Type', 'GDPress' ),
			'event' 	=> __( 'Event Type', 'GDPress' ),
			'ip' 		=> __( 'Event Ip', 'GDPress' ),
			'agent'		=> __( 'Event UserAgent', 'GDPress' ),
		);

		foreach ( (array) $events as $event )
		{
			$data = array();

			foreach ( $properties as $key => $name )
			{
				$value = '';

				switch( $key )
				{
					case 'action_name' :
						$action_name = GDP_Event_meta::get( $event->id, 'action' );
						$value = ( $action_name ) ? wp_user_request_action_description( $action_name ) : null;
 					break;
					default :
						$value = $event->{$key};
					break;
				}

				if ( empty( $value ) ) continue;
				$data[] = array( 'name' => $name, 'value' => $value, );
			}

			$this->export['data'][] = array(
				'group_id'    => 'gdp_events',
				'group_label' => __( 'GDPR Events > Collected Data', 'GDPress' ),
				'group_description' => __( 'Data Subject collected events.', 'GDPress' ),
				'item_id'     => "gdp_event-{$event->id}",
				'data'        => $data,
			);
		}

		$this->export['done'] = ( $total == $current );
		
		return $this->export;
	}
}
new GDP_WP_Privacy_exporter_gdpress( __( 'GDPress events', 'GDPress' ) );
}